---
title: List all WAF policies
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Application Security
---

# List all WAF policies{% #list-all-waf-policies %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                     |
| ----------------- | -------------------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/remote_config/products/asm/waf/policies |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/remote_config/products/asm/waf/policies |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/remote_config/products/asm/waf/policies      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/remote_config/products/asm/waf/policies      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/remote_config/products/asm/waf/policies  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/remote_config/products/asm/waf/policies     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/remote_config/products/asm/waf/policies |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/remote_config/products/asm/waf/policies |

### Overview

Retrieve a list of WAF policies.

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response object that includes a list of WAF policies.

| Parent field | Field                         | Type      | Description                                                                                                                      |
| ------------ | ----------------------------- | --------- | -------------------------------------------------------------------------------------------------------------------------------- |
|              | data                          | [object]  | The WAF policy data.                                                                                                             |
| data         | attributes                    | object    | A WAF policy.                                                                                                                    |
| attributes   | description [*required*] | string    | Description of the WAF policy.                                                                                                   |
| attributes   | isDefault                     | boolean   | Make this policy the default policy. The default policy is applied to every service not specifically assigned to another policy. |
| attributes   | name [*required*]        | string    | The name of the WAF policy.                                                                                                      |
| attributes   | protectionPresets             | [string]  | Presets enabled on this policy.                                                                                                  |
| attributes   | rules                         | [object]  | Rule overrides applied by the policy.                                                                                            |
| rules        | blocking [*required*]    | boolean   | When blocking is enabled, the rule will block the traffic matched by this rule.                                                  |
| rules        | enabled [*required*]     | boolean   | When false, this rule will not match any traffic.                                                                                |
| rules        | extended_data_collection      | boolean   | When true, collects additional data from the WAF for this rule.                                                                  |
| rules        | id [*required*]          | string    | Override the parameters for this WAF rule identifier.                                                                            |
| attributes   | rulesets                      | [object]  | **DEPRECATED**: Deprecated: Ruleset overrides. Use `protectionPresets` instead.                                                  |
| rulesets     | blocking [*required*]    | boolean   | When blocking is enabled, the ruleset will block the traffic it matches.                                                         |
| rulesets     | enabled [*required*]     | boolean   | When false, this ruleset will not match any traffic.                                                                             |
| rulesets     | id [*required*]          | string    | The identifier of the ruleset to override.                                                                                       |
| attributes   | scope                         | [object]  | The scope of the WAF policy.                                                                                                     |
| scope        | env [*required*]         | string    | The environment scope for the WAF policy.                                                                                        |
| scope        | service [*required*]     | string    | The service scope for the WAF policy.                                                                                            |
| attributes   | version                       | int64     | Version of the WAF ruleset maintained by Datadog used by this policy. 0 is the default value.                                    |
| data         | id                            | string    | The ID of the policy.                                                                                                            |
| data         | meta                          | object    | Metadata associated with the WAF policy.                                                                                         |
| meta         | added_at                      | date-time | The date and time the WAF policy was created.                                                                                    |
| meta         | added_by                      | string    | The handle of the user who created the WAF policy.                                                                               |
| meta         | added_by_name                 | string    | The name of the user who created the WAF policy.                                                                                 |
| meta         | modified_at                   | date-time | The date and time the WAF policy was last updated.                                                                               |
| meta         | modified_by                   | string    | The handle of the user who last updated the WAF policy.                                                                          |
| meta         | modified_by_name              | string    | The name of the user who last updated the WAF policy.                                                                            |
| data         | type                          | enum      | The type of the resource. The value should always be `policy`. Allowed enum values: `policy`                                     |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "attributes": {
        "description": "Policy applied to internal web applications.",
        "isDefault": false,
        "name": "Internal Network Policy",
        "protectionPresets": [
          "attack-tools"
        ],
        "rules": [
          {
            "blocking": false,
            "enabled": true,
            "extended_data_collection": false,
            "id": "rasp-001-002"
          }
        ],
        "rulesets": [
          {
            "blocking": false,
            "enabled": true,
            "id": "attack_tool"
          }
        ],
        "scope": [
          {
            "env": "prod",
            "service": "billing-service"
          }
        ],
        "version": 0
      },
      "id": "2857c47d-1e3a-4300-8b2f-dc24089c084b",
      "meta": {
        "added_at": "2021-01-01T00:00:00Z",
        "added_by": "john.doe@datadoghq.com",
        "added_by_name": "John Doe",
        "modified_at": "2021-01-01T00:00:00Z",
        "modified_by": "john.doe@datadoghq.com",
        "modified_by_name": "John Doe"
      },
      "type": "policy"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Not Authorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/remote_config/products/asm/waf/policies" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
List all WAF policies returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.application_security_api import ApplicationSecurityApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = ApplicationSecurityApi(api_client)
    response = api_instance.list_application_security_waf_policies()

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# List all WAF policies returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::ApplicationSecurityAPI.new
p api_instance.list_application_security_waf_policies()
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// List all WAF policies returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewApplicationSecurityApi(apiClient)
	resp, r, err := api.ListApplicationSecurityWAFPolicies(ctx)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ApplicationSecurityApi.ListApplicationSecurityWAFPolicies`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ApplicationSecurityApi.ListApplicationSecurityWAFPolicies`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// List all WAF policies returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ApplicationSecurityApi;
import com.datadog.api.client.v2.model.ApplicationSecurityPolicyListResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ApplicationSecurityApi apiInstance = new ApplicationSecurityApi(defaultClient);

    try {
      ApplicationSecurityPolicyListResponse result =
          apiInstance.listApplicationSecurityWAFPolicies();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling ApplicationSecurityApi#listApplicationSecurityWAFPolicies");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// List all WAF policies returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_application_security::ApplicationSecurityAPI;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = ApplicationSecurityAPI::with_config(configuration);
    let resp = api.list_application_security_waf_policies().await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * List all WAF policies returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.ApplicationSecurityApi(configuration);

apiInstance
  .listApplicationSecurityWAFPolicies()
  .then((data: v2.ApplicationSecurityPolicyListResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
